package org.springblade.estate.feign;

import io.swagger.annotations.ApiParam;
import lombok.AllArgsConstructor;
import javax.validation.Valid;
import org.springblade.core.mp.support.Condition;
import org.springblade.core.tool.utils.Func;
import org.springframework.cloud.openfeign.SpringQueryMap;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.bind.annotation.RequestParam;
import org.springblade.estate.entity.Feedback;
import org.springblade.estate.vo.FeedbackVO;
import org.springblade.estate.wrapper.FeedbackWrapper;
import org.springblade.estate.service.IFeedbackService;
import org.springblade.core.boot.ctrl.BladeController;
import java.util.List;
/**
 *  client
 *
 * @author lianghanqiang
 * @since 2021-05-18
 */

@AllArgsConstructor
@RestController
@RequestMapping("/feign/feedback")

public class FeedbackClient implements IFeedbackClient {

    private final IFeedbackService feedbackService;

        /**
     * 详情
     */
    @Override
    @GetMapping("/detail")
    public FeedbackVO detail(@SpringQueryMap Feedback feedback) {
        Feedback detail = feedbackService.getOne(Condition.getQueryWrapper(feedback));
        return FeedbackWrapper.build().entityVO(detail);
        }

    /**
     * 查询
     */
    @Override
    @GetMapping("/list")
    public List<FeedbackVO> list(@SpringQueryMap Feedback feedback) {
        return FeedbackWrapper.build().listVO(feedbackService.list(Condition.getQueryWrapper(feedback)));
        }



    /**
     * 新增
     */
    @Override
    @PostMapping("/save")
    public boolean save(@Valid @RequestBody Feedback feedback) {
        return feedbackService.save(feedback);
        }

    /**
     * 修改
     */
    @Override
    @PostMapping("/update")
    public boolean update(@Valid @RequestBody Feedback feedback) {
        return feedbackService.updateById(feedback);
        }

    /**
     * 新增或修改
     */
    @Override
    @PostMapping("/submit")
    public boolean submit(@Valid @RequestBody Feedback feedback) {
        return feedbackService.saveOrUpdate(feedback);
        }


    /**
     * 删除
     */
    @Override
    @PostMapping("/remove")
    public boolean remove(@ApiParam(value = "主键集合", required = true) @RequestParam String ids) {
        return feedbackService.deleteLogic(Func.toLongList(ids));
        }


}
